
from sage.matrix.constructor import matrix
from sage.modules.module import Module
from sage.modules.free_module import FreeModule_generic
from sage.modules.matrix_morphism import MatrixMorphism
from sage.categories.action import Action
from sage.modules.free_module_element import FreeModuleElement_generic_sparse, vector
import sage.categories.category_types
from sage.categories.category_types import Modules
from sage.categories.category_types import AlgebraModules
#execfile("/home/cn/steenrod_module.py")
from sage.algebras.steenrod_algebra_element import SteenrodAlgebraElement

class SteenrodAction_vs(Action):
    def __init__(self, M, is_left):
        Action.__init__(self,SteenrodAlgebra(M._prime),M,is_left=is_left,op=operator.mul)
        print "xxx", self.codomain(), self.domain(), self.operation(), self.is_left()

    def _call_(self, a, b):
        #print "xxx", self.codomain(), self.domain(), self.operation(), self.is_left()
        #self.M.matrix(a) * b
        #print "action %s / %s" % (a,b)
        if self.is_left():
            dict = self.codomain()._lactions
            v = b._data
            result = 0 * v
            ad = a._basis_dictionary('milnor')
            for mb in ad.keys():
                if dict.has_key(mb):
                    mat = dict[mb]
                    result += ad[mb] * mat * v        
            return SteenrodModuleElement_vector_space(self.codomain(),result) 
        else:
            dict = self.codomain()._ractions
            v = a._data
            result = 0 * v
            bd = b._basis_dictionary('milnor')
            for mb in bd.keys():
                if dict.has_key(mb):
                    mat = dict[mb]
                    result += bd[mb] * v * mat
            return SteenrodModuleElement_vector_space(self.codomain(),result) 

def direct_sum(L):
    pass

#class SteenrodModule(Module, FreeModule_generic):
class SteenrodModule(Module):
    """
    Might have a left action, might have a right action.
    """
    def __init__(self, prime=None, profile=None, algebra=None, name_prefix=None, name_override=None):
        self._prime = prime
        Parent.__init__(self,base=GF(prime),categories=[AlgebraModules(SteenrodAlgebra(prime))], names=name_prefix)
        pass
    
    def gen(self, m, n=None):
        """
        Returns the m'th generator if n is None, or the nth generator of degree m.
        """
        pass
    #def inject_variables(self, scope=None, verbose=True):
    #    pass
    def basis_in_range(self, islice=None, eslice=None):
        """
        islice -- internal degrees
        eslice -- exterior degrees
        """
        # fallback implementation: get all generators and filter by degrees
        res = []
        for g in self._vector_space_basis():
            d = g.degrees()
            if (islice is None or d['i'] in islice) and (eslice is None or d['e'] in eslice):
                res.append(g)
        return res

    def bbox(self):
        """
        Returns a dict with keys 'imin', 'imax', 'emin', 'emax'
        """
        pass
    def check_adem_relations(self, on_left=True):
        pass
    def check_associativity(self, on_left=True):
        pass
    def action_is_on_left(self):
        pass
    def truncate(self, upper_bound=None, lower_bound=None):
        pass
    def direct_sum(self, M):
        pass
    def tensor_product(self, M):
        pass
    def _convert_to_vs(self):
        pass
    def _convert_to_fp(self):
        pass
    def _convert_to_tcl(self):
        pass
    def degree(self):
        #total degree = dim as F_p vector space.
        pass

    def dualized(self):
        return self._vs_dual()

    def suspended(self,ishift,eshift=0):
        return self._suspended(ishift,eshift);

class SteenrodModule_vector_space(SteenrodModule): 

    def _unfiddle_action(self,adict):
        res={}
        for k in adict:
            if isinstance(k,SteenrodAlgebraElement):
                x = k._basis_dictionary('milnor')
                if len(x) != 1:
                    raise ValueError, "dictionary key %s not a Milnor basis element" % k
                mb=x.keys()[0]
                if x[mb] != 1:
                    raise ValueError, "dictionary key %s coefficient is not 1" % k
                res[mb]=adict[k]
            else:
                res[k]=adict[k]
        return res
            
    def _vs_dual(self):
        """
        create the vector space dual with the conjugated actions  
        """

        idegs = [-x for x in self._idegrees]
        edegs = [-x for x in self._edegrees]
        lact = {}
        ract = {}
        if not self._ractions is None:
            for op in self._ractions.keys():
                lact[op] = self._ractions[op].transpose()
        if not self._lactions is None:
            for op in self._lactions.keys():
                ract[op] = self._lactions[op].transpose()
        return SteenrodModule_vector_space(self._algebra,idegs,edegs,name_prefix=self._name_prefix,actions=lact,right_actions=ract,profile=self._profile)

    def suspended(self,ishift,eshift=0):
        """
        create a suspension
        """
        idegs=[x+ishift for x in self._idegrees]
        edegs=[x+eshift for x in self._edegrees]
        return SteenrodModule_vector_space(self._algebra,idegs,edegs,name_prefix=self._name_prefix,actions=self._lactions,right_actions=self._ractions,profile=self._profile)

    def __init__(self,algebra, idegrees, edegrees, name_prefix='m', actions=None, right_actions=None, profile=None):
        """
        action dictionaries: key=Milnor basis element, value=Matrix
        """
        if hasattr(algebra,"prime"):
            self._prime = algebra.prime
        else:
            raise ValueError, "algebra not recognized"

        self._algebra = algebra
        self._idegrees=idegrees
        self._edegrees=edegrees
        self._name_prefix=name_prefix
        self._lactions = self._unfiddle_action(actions)
        self._ractions = self._unfiddle_action(right_actions)
        self._dim = len(idegrees)
        self._profile = profile

        SteenrodModule.__init__(self,prime=self._prime,profile=profile,algebra=algebra,name_prefix=name_prefix)

        #print self.parent()
        print self.base()
        print self.category()

        #self._base = SteenrodAlgebra(self._prime)

        raction = SteenrodAction_vs(self, is_left=0)
        laction = SteenrodAction_vs(self, is_left=1)
        print laction
        print raction
        #self._populate_coercion_lists_()
        self._populate_coercion_lists_(action_list=[laction, raction])

    def _element_constructor_(self,x):
        print "eleco",x
        if isinstance(x,vector):
            return SteenrodModuleElement_vector_space(self,x)

        raise ValueError, "cannot make %s a module element" % x

    def _repr_(self):
        return "SteenrodModule_vector_space(%s,%s,%s,actions=%s,right_actions=%s,profile=%s)" % (self._algebra,self._idegrees,self._edegrees,self._lactions,self._ractions,self._profile)

    def ngens(self):
        return len(self._idegrees)

    def gen(self,num):
        v = [0]*self.ngens()
        v[num]=1
        return SteenrodModuleElement_vector_space(self,vector(GF(self._prime),v))

    def _vector_space_basis(self):
        #print "x",self._idegrees, len(self._idegrees)
        l=len(self._idegrees)
        return [self.gen(i) for i in range(l)]

    def bbox(self):
        """
        Returns a dict with keys 'imin', 'imax', 'emin', 'emax'
        """
        res={}
        res['imin'] = min(self._idegrees)
        res['imax'] = max(self._idegrees)
        res['emin'] = min(self._edegrees)
        res['emax'] = max(self._edegrees)
        return res

class SteenrodModuleElement(ModuleElement):
    def __init__(self,parent):
        ModuleElement.__init__(self,parent)

    def degrees(self):
        """
        return dictionary with keys 'i' and 'e'
        """
        raise NotImplementedError, "degrees not implemented"

class SteenrodModuleElement_vector_space(SteenrodModuleElement):
    
    def __init__(self,module,vector):
        SteenrodModuleElement.__init__(self,module)
        self._data = vector

    def _repr_(self):
        s = ""
        p=self.parent()
        N = p.variable_names()
        for i in range(len(self._data)):
            if self._data[i] == 1:
                s += " + %s"%N[i]
            elif self._data[i]:
                s += " + %s*%s"%(self._data[i],N[i])
        if len(s) > 0:
            s = s[3:]
        else:
            s = "0"
        return s
        #return "x%s" % self._data
    
    def _add_(self,x):
        return SteenrodModuleElement_vector_space(self.parent(),self._data + x._data)
    def _sub_(self,x):
        return SteenrodModuleElement_vector_space(self.parent(),self._data - x._data)
         
    def degrees(self):
        """
        return dictionary with keys 'i' and 'e'
        """
        s = ""
        p=self.parent()
        N = p.variable_names()
        ideg = None
        edeg = None
        for i in range(len(self._data)):
            if self._data[i] != 0:
                if ideg is None:
                    ideg = p._idegrees[i]
                elif ideg != p._idegrees[i]:
                    raise ValueError, "element %s is not homogeneous" % self
                if edeg is None:
                    edeg = p._edegrees[i]
                elif edeg != p._edegrees[i]:
                    raise ValueError, "element %s is not homogeneous" % self
        if ideg is None:
            raise ValueError, "degree not well defined for 0"
        return {'i':ideg,'e':edeg}

    def __getitem__(self,gen):
        """
        returns the inner product
        """
        s = ""
        p=self.parent()
        N = p.variable_names()
        res = 0
        for i in range(len(self._data)):
            res += gen._data[i]*self._data[i]
        return res

def MooreSpace_generic(prime,name_prefix='x'):
    unit = matrix(GF(prime),2,2,[1,0,0,1])
    opq0 = matrix(GF(prime),2,2,[0,1,0,0])
    actions = {}
    A=SteenrodAlgebra(prime)
    actions[A.P(0)] = unit
    actions[A.Q(0)] = opq0
    return SteenrodModule_vector_space(SteenrodAlgebra(prime),[0,1],[0,1],name_prefix=name_prefix,actions=actions,right_actions=actions)

def MooreSpace(prime,name_prefix='x'):
    if prime != 2:
        return MooreSpace_generic(prime,name_prefix)
    unit = matrix(GF(prime),2,2,[1,0,0,1])
    opq0 = matrix(GF(prime),2,2,[0,1,0,0])
    actions = {}
    A2=SteenrodAlgebra(2)
    actions[A2.Sq(0)] = unit
    actions[A2.Sq(1)] = opq0
    return SteenrodModule_vector_space(SteenrodAlgebra(prime),[0,1],[0,0],name_prefix=name_prefix,actions=actions,right_actions=actions)

cm = sage.structure.element.get_coercion_model()

M = MooreSpace(5,name_prefix='m')
A = SteenrodAlgebra(5)
b = M.gen(0)
t = M.gen(1)

print cm.explain(SteenrodAlgebra(5).P(0),M.gen(1),operator.mul)

print M
print M.gen(0)
print M.gen(1)
print M._vector_space_basis()

if True:
    for a in [A.P(0),A.Q(1),A.P(1)]:
        for m in [M.gen(0),M.gen(1)]:
            print "   %s * %s = %s" % (a,m,a*m)
            print "   %s * %s = %s" % (m,a,m*a)

print cm.explain(Integer(3),b,operator.mul)

print b+t, " / ", b-t 
print 3*b
print 3*b-2*t
b2=2*b
s=b2+t
print b2.degrees()
#print s.degrees()
               
class SteenrodModuleYacopWrapper:
    """
    A wrapper around a SteenrodModule that provides the
    SteenrodAlgebraSmashable interface required for the 
    cohomology calculation
    """

    def __init__(self,module):
        self.mod = module
        self._fsums = FormalSums(GF(self.mod._prime))
        self._prime = self.mod._prime
        self._doublei = False
        if self._prime == 2:
            self._doublei = True

    def bbox(self):
        b = self.mod.bbox()
        b['smax'] = b['smin'] = 0
        if self._doublei:
            b['imax'] = b['imax']*2
            b['imin'] = b['imin']*2
        return b

    def basis(self,region):
        im = region['imax']
        if self._doublei:
            im = im/2
        bbx= self.mod.bbox()
        return self.mod.basis_in_range(range(bbx['imin'],im+1))

    def diff(self,baselem): 
        return FormalSum([],parent=self._fsums) 
    
    def actR(self,baselem,a):
        prod = baselem*a
        lst = [(prod[g],g) for g in self.mod.basis_in_range()]
        print "%s * %s = %s = %s" % (baselem,a,prod,lst) 
        return FormalSum(lst,parent=self._fsums) 

    def degrees(self,baselem):
        r=baselem.degrees()
        r['s']=0
        if self._doublei:
            r['i'] = r['i']*2
        return r

    def _make_element_(self,string):
        print "mk",string
        return self.mod(string)

if False:
    Y=SteenrodModuleYacopWrapper(M)

    D=SteenrodAlgebraSmashResolution(C,Y)
    D.extend(s=20,n=500)
    D.gui()

if False:
    # moore space, assumes 2-primary gfr C2
    Y=SteenrodModuleYacopWrapper(MooreSpace(2,name_prefix='j'))

    D=SteenrodAlgebraSmashResolution(C2,Y)
    D.extend(s=30,n=60)
    D.gui()

if True:
    # question mark cpx, assumes 2-primary gfr C2
    prime=2
    unit = matrix(GF(prime),3,3,[1,0,0,0,1,0,0,0,1])
    opq0 = matrix(GF(prime),3,3,[0,1,0,0,0,0,0,0,0])
    opp1 = matrix(GF(prime),3,3,[0,0,0,0,0,1,0,0,0])
    ractions = {}
    A2=SteenrodAlgebra(2)
    ractions[A2.Sq(0)] = unit
    ractions[A2.Sq(1)] = opq0
    ractions[A2.Sq(2)] = opp1
    ractions[A2.Sq(3)] = opq0*opp1
    ractions[A2.Sq(0,1)] = ractions[A2.Sq(3)]
    lactions=ractions
    #lactions[A2.Sq(1,1)] = ractions[A2.Sq(3)]
    Q=SteenrodModule_vector_space(SteenrodAlgebra(prime),[0,1,3],[0,0,0],name_prefix='q',actions=lactions,right_actions=ractions)

    Z= Q.dualized().suspended(5)
    Y=SteenrodModuleYacopWrapper(Z)

    D=SteenrodAlgebraSmashResolution(C2,Y)
    D.extend(s=30,n=60)
    D.gui()

    for k in D.homology(n=4): 
        print k, " <- " , D.cycle(k)
        
